//+---------------------------------------------------------------------+
//|                                                      GG-RSI-CCI.mq5 |
//|                                            Copyright  2009, GGekko |
//|                                            http://www.fx-ggekko.com |
//+---------------------------------------------------------------------+ 
//|          SmoothAlgorithms.mqh |
//|   (): __\\MQL5\Include        |
//+---------------------------------------------------------------------+
#property copyright "Copyright  2009, GGekko"
#property link "http://www.fx-ggekko.com" 
//----   
#property version   "1.10"
//----     
#property indicator_separate_window 
//----    2
#property indicator_buffers 2 
//----     
#property indicator_plots   1
//----       
#property indicator_height 10
//----        
#property indicator_maximum +0.9
#property indicator_minimum +0.4
//+-----------------------------------+
//|                 |
//+-----------------------------------+
#define RESET 0 //        
//+-----------------------------------+
//|       |
//+-----------------------------------+
//----      
#property indicator_type1 DRAW_COLOR_HISTOGRAM
//----      
#property indicator_color1 clrDeepPink,clrGray,clrDodgerBlue
//----   - 
#property indicator_style1 STYLE_SOLID
//----     2
#property indicator_width1 2
//----   
#property indicator_label1 "GG-RSI-CCI"

//+-----------------------------------+
//|          |
//+-----------------------------------+
#include <SmoothAlgorithms.mqh> 
//+-----------------------------------+

//----    CXMA   SmoothAlgorithms.mqh
CXMA XMA1,XMA2,XMA3,XMA4;
//+-----------------------------------+
//|             |
//+-----------------------------------+
/*enum Smooth_Method -     SmoothAlgorithms.mqh
  {
   MODE_SMA_,  //SMA
   MODE_EMA_,  //EMA
   MODE_SMMA_, //SMMA
   MODE_LWMA_, //LWMA
   MODE_JJMA,  //JJMA
   MODE_JurX,  //JurX
   MODE_ParMA, //ParMA
   MODE_T3,    //T3
   MODE_VIDYA, //VIDYA
   MODE_AMA,   //AMA
  }; */
//+-----------------------------------+
//|         |
//+-----------------------------------+
input int IndPeriod=8; //  RSI  CCI
input ENUM_APPLIED_PRICE Applied_Price=PRICE_CLOSE; // 
input Smooth_Method SmoothMethod=MODE_SMMA; // 
input int Period1=14; //  
input int Period2=20; //  
input int Smooth_Phase=100;   // ,
                              // JJMA    -100 ... +100,     ;
//  VIDIA   CMO,  AMA    
//+-----------------------------------+
//----      
int RSI_Handle,CCI_Handle;
//----      
int min_rates,min_rates_total;
//----   ,    
//      
double IndBuffer[],ColorIndBuffer[];
//+------------------------------------------------------------------+    
//| GG-RSI-CCI indicator initialization function                     | 
//+------------------------------------------------------------------+  
void OnInit()
  {
//----     
   int min_rates_1=XMA1.GetStartBars(SmoothMethod,Period1,Smooth_Phase);
   int min_rates_2=XMA1.GetStartBars(SmoothMethod,Period2,Smooth_Phase);
   min_rates=IndPeriod;
   min_rates_total=min_rates+MathMax(min_rates_1,min_rates_2);

//----    iRSI  
   RSI_Handle=iRSI(NULL,PERIOD_CURRENT,IndPeriod,Applied_Price);
   if(RSI_Handle==INVALID_HANDLE) Print("      iRSI");

//----    iCCI 
   CCI_Handle=iCCI(NULL,PERIOD_CURRENT,IndPeriod,Applied_Price);
   if(CCI_Handle==INVALID_HANDLE) Print("      iCCI");

//----    IndBuffer   
   SetIndexBuffer(0,IndBuffer,INDICATOR_DATA);
//----      
   PlotIndexSetInteger(0,PLOT_DRAW_BEGIN,min_rates_total);
//----   ,      
   PlotIndexSetDouble(0,PLOT_EMPTY_VALUE,0.0);
//----       
   ArraySetAsSeries(IndBuffer,true);

//----     ,     
   SetIndexBuffer(1,ColorIndBuffer,INDICATOR_COLOR_INDEX);
//----       
   ArraySetAsSeries(ColorIndBuffer,true);

//----       
   XMA1.XMALengthCheck("Period1",Period1);
   XMA1.XMALengthCheck("Period2",Period2);
//----       
   XMA1.XMAPhaseCheck("Smooth_Phase",Smooth_Phase,SmoothMethod);

//---           
   IndicatorSetString(INDICATOR_SHORTNAME,"GG-RSI-CCI");
//---     
   IndicatorSetInteger(INDICATOR_DIGITS,0);
//----  
  }
//+------------------------------------------------------------------+  
//| GG-RSI-CCI iteration function                                    | 
//+------------------------------------------------------------------+  
int OnCalculate(
                const int rates_total,    //       
                const int prev_calculated,//       
                const datetime &time[],
                const double &open[],
                const double& high[],     //       
                const double& low[],      //        
                const double &close[],
                const long &tick_volume[],
                const long &volume[],
                const int &spread[]
                )
  {
//----       
   if(BarsCalculated(RSI_Handle)<rates_total
      || BarsCalculated(CCI_Handle)<rates_total
      || rates_total<min_rates_total) return(RESET);

///----    
   int limit,bar,to_copy,MaxBar;
   double x1cci,x2cci,x1rsi,x2rsi;
   double CCI[],RSI[];

//----    limit    
   if(prev_calculated>rates_total || prev_calculated<=0)//      
      limit=rates_total-min_rates-1; //      
   else limit=rates_total-prev_calculated; //      

   to_copy=limit+1;
   MaxBar=rates_total-min_rates-1;

//----         
   ArraySetAsSeries(CCI,true);
   ArraySetAsSeries(RSI,true);

//----        
   if(CopyBuffer(RSI_Handle,0,0,to_copy,RSI)<=0) return(RESET);
   if(CopyBuffer(CCI_Handle,0,0,to_copy,CCI)<=0) return(RESET);

//----    
   for(bar=limit; bar>=0 && !IsStopped(); bar--)
     {
      x1rsi=XMA1.XMASeries(MaxBar,prev_calculated,rates_total,SmoothMethod,Smooth_Phase,Period1,RSI[bar],bar,true);
      x2rsi=XMA2.XMASeries(MaxBar,prev_calculated,rates_total,SmoothMethod,Smooth_Phase,Period2,RSI[bar],bar,true);

      x1cci=XMA3.XMASeries(MaxBar,prev_calculated,rates_total,SmoothMethod,Smooth_Phase,Period1,CCI[bar],bar,true);
      x2cci=XMA4.XMASeries(MaxBar,prev_calculated,rates_total,SmoothMethod,Smooth_Phase,Period2,CCI[bar],bar,true);

      IndBuffer[bar]=1;

      if(x1rsi>x2rsi && x1cci>x2cci) ColorIndBuffer[bar]=2;
      else if(x1rsi<x2rsi && x1cci<x2cci) ColorIndBuffer[bar]=0;
      else ColorIndBuffer[bar]=1;
     }
//----     
   return(rates_total);
  }
//+------------------------------------------------------------------+
